'use strict';

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol ? "symbol" : typeof obj; }; /* eslint-disable max-len */

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = patch;

var _immutable = require('immutable');

function safeString(o) {
  var stro = 'String representation of object cannot be computed';
  try {
    stro = '' + o;
  } catch (e) {}
  return stro;
}

function type(o) {
  return '[' + (typeof o === 'undefined' ? 'undefined' : _typeof(o)) + ']';
}

var gets = {
  'default': function _default(o, k, d) {
    if (typeof k !== 'string') {
      throw new Error('cannot resolve non-string property ' + type(k) + ' ' + safeString(k));
    }
    if ((typeof o === 'undefined' ? 'undefined' : _typeof(o)) !== 'object') {
      throw new Error('cannot resolve property ' + k + ' in object of type ' + (typeof o === 'undefined' ? 'undefined' : _typeof(o)) + ' (' + safeString(o) + ')');
    }
    if (k in o) {
      return o[k];
    }
    return d;
  },

  'immutable': function immutable(o, k, d) {
    if (_immutable.Iterable.isIterable(o)) {
      return o.get(k, d);
    }
    if (typeof k !== 'string') {
      throw new Error('cannot resolve non-string property ' + type(k) + ' ' + safeString(k));
    }
    if ((typeof o === 'undefined' ? 'undefined' : _typeof(o)) !== 'object') {
      throw new Error('cannot resolve property ' + k + ' in object of type ' + (typeof o === 'undefined' ? 'undefined' : _typeof(o)) + ' (' + safeString(o) + ')');
    }
    if (k in o) {
      return o[k];
    }
    return d;
  },

  'safe': function safe(o, k, d) {
    if (_immutable.Iterable.isIterable(o)) {
      var res = o.get(k, d);
      if (res === undefined) {
        throw new Error('Key Error: object with keys ' + (0, _immutable.List)(o.keys()).toJS() + ' does not contain property ' + k);
      }
      return o.get(k, d);
    }
    if (typeof k !== 'string') {
      throw new Error('cannot resolve non-string property ' + type(k) + ' ' + safeString(k));
    }
    if ((typeof o === 'undefined' ? 'undefined' : _typeof(o)) !== 'object') {
      throw new Error('cannot resolve property ' + k + ' in object of type ' + (typeof o === 'undefined' ? 'undefined' : _typeof(o)) + ' (' + safeString(o) + ')');
    }
    if (k in o) {
      return o[k];
    }
    if (d === undefined) {
      throw new Error('Key Error: object with keys ' + Object.keys(o) + ' does not contain property ' + k);
    }
    return d;
  }
};

function patch(what) {
  if (what in patch) {
    if ((typeof global === 'undefined' ? 'undefined' : _typeof(global)) === 'object') {
      global.__extenible_get__ = patch[what];
    }
    if ((typeof window === 'undefined' ? 'undefined' : _typeof(window)) === 'object') {
      window.__extenible_get__ = patch[what];
    }
  } else {
    throw new Error('patch argument must be one of ' + Object.keys(gets));
  }
}